#!/bin/sh
# $Id: mk-patchkit.sh,v 1.3 2002/10/31 22:25:13 mikpe Exp $

KVER=$1
PVER=$2

files_x86="drivers/perfctr/x86.c include/asm-i386/perfctr.h"

files_virtual="drivers/perfctr/virtual.c include/linux/vperfctr.h"

files_glue="drivers/perfctr/Kconfig drivers/perfctr/Makefile"

files_kernel="CREDITS MAINTAINERS arch/i386/Kconfig arch/i386/kernel/entry.S arch/i386/kernel/i8259.c arch/i386/kernel/process.c arch/i386/mach-generic/irq_vectors.h drivers/Makefile include/asm-i386/apic.h include/asm-i386/processor.h include/asm-i386/unistd.h kernel/timer.c"

doit() {
    for f in $1 ; do
	echo "diff -uN linux-$KVER/$f linux-$KVER.perfctr-$PVER/$f"
	diff -uN linux-$KVER/$f linux-$KVER.perfctr-$PVER/$f
    done > patch-$KVER-perfctr-$PVER-$2
    diffstat patch-$KVER-perfctr-$PVER-$2 > diffstat.patch-$KVER-perfctr-$PVER-$2
}

doit "$files_x86" "1.x86"
doit "$files_virtual" "2.virtual"
doit "$files_glue" "3.glue"
doit "$files_kernel" "4.kernel"
