/* $Id: compat.h,v 1.28 2002/10/31 01:43:08 mikpe Exp $
 * Performance-monitoring counters driver.
 * Compatibility definitions for 2.4/2.5 kernels.
 *
 * Copyright (C) 1999-2002  Mikael Pettersson
 */
#include <linux/fs.h>
#include <linux/version.h>

#if defined(CONFIG_X86) && LINUX_VERSION_CODE < KERNEL_VERSION(2,4,11) && !defined(cpu_relax)
#define cpu_relax()		rep_nop()
#endif

/* PROC_I() was introduced in 2.5.4 */
#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,5,4)
#include <linux/proc_fs.h>
#else /* for 2.4 only, not 2.2 */
#define PROC_I(inode) (&(inode)->u.proc_i)
#endif

/* remap_page_range() changed in 2.5.3-pre1 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,3)
#include <linux/mm.h>
static inline int perfctr_remap_page_range(struct vm_area_struct *vma, unsigned long from, unsigned long to, unsigned long size, pgprot_t prot)
{
	return remap_page_range(from, to, size, prot);
}
#undef remap_page_range
#define remap_page_range(vma,from,to,size,prot) perfctr_remap_page_range((vma),(from),(to),(size),(prot))
#endif

/* put_task_struct() was introduced in 2.5.4 */
#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,4)
#define put_task_struct(tsk)	free_task_struct((tsk))
#endif

#if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
#ifdef CONFIG_PREEMPT
#error "not yet ported to 2.4+PREEMPT"
#endif
#define preempt_disable()	do{}while(0)
#define preempt_enable()	do{}while(0)
#endif
